<?php

class Search {
	
	//---------------------------------------------------------
	//  コントロール設定
	//---------------------------------------------------------
	
	public static function control() {
		
		// コントロール設定を返す
		return array(true, true, 'Header', 'Footer');
		
	}
	
	//---------------------------------------------------------
	//  詳細ログ表示
	//---------------------------------------------------------
	
	public static function execute() {
		
		// DBクラスを取得
		$db = $GLOBALS['obj']['db'];
		
		// テンプレートクラスを取得
		$tmpl = $GLOBALS['obj']['tmpl'];
		
		////////////////////////////////////////////////////////////
		
		// メイン、ナビリンク、フッター テンプレートを取得
		list($body, $navLink, $foot) = $tmpl->read('visit.htm');
		
		// クラスを読み込み
		include(WORK_DIR . '/actions/Visit.php');
		
		////////////////////////////////////////////////////////////
		
		// 変数を初期化
		$wheres = array();
		$table = '';
		$where = 'and ';
		$whereUA = "ua_type != 'Robot'";
		$limit = '';
		$opt = '';
		$d = 'xx';
		
		// インデントタブを設定
		$tab1 = "\t\t\t\t";
		$tab2 = $tab1 . "\t";
		
		////////////////////////////////////////////////////////////
		
		// リクエストメソッドを取得
		$method = $_SERVER['REQUEST_METHOD'];
		
		// GETメソッドの時
		if ($method === 'GET') {
			
			// パラメータ種別を取得
			$param = $GLOBALS['args'][1];
			
			// ID検索の時
			if ($param === 'visitor_id') {
				
				// IDを取得
				$visitorId = $GLOBALS['args'][2];
				
				// 処理実行後以下の処理を省略
				return self::visitorId($db, $tmpl, $body, $visitorId);
				
			}
			
			// 年月を取得
			$y = $GLOBALS['args'][2];
			$m = $GLOBALS['args'][3];
			$d = $GLOBALS['args'][4];
			
			// 検索項目名を取得
			$item = $GLOBALS['args'][5];
			
			// 検索オプションを取得
			$opt = (isset($GLOBALS['args'][6])) ? $GLOBALS['args'][6] : '';
			
			// 日付の指定がある時は条件に足す
			if ($d !== 'xx') {
				$where .= "date = '$y-$m-$d' and ";
			}
			
			// オプションをリセット
			if ($param === 'host_domain' || $opt === 'pickup') {
				$opt = '';
			}
			
			// 端末機種の時
			if ($param === 'device') {
				
				// 特定の文字をエスケープ
				//$item = quotemeta($item);
				
				// 統合の時の時
				if ($opt === 'group') {
					
					// where区句をリセット
					$where= '';
					
					// iniファイルをパース
					$device = parse_ini_file(WORK_DIR . '/templates/ini/device.ini');
					
					// データ取得ループ
					foreach ($device as $key => $val) {
						
						// 端末愛称の先頭にマッチした時
						if (preg_match("/$item/A", $val)) {
							
							// 接続語を追記
							$where .= ($where) ? ' or ' : 'and (';
							
							// 端末機種名を追記
							$where .= "$param = '$key'";
							
						}
						
					}
					
					// where句に追記
					$where .= ($where) ? ')' : "and $param = '$item'";
					
				}
				
				// オプションがない時
				else {
					$where .= "$param = '$item'";
				}
				
			}
			
			// 検索語：単語の時はフレーズに変更
			elseif ($param === 'search_word') {
				$where .= "search_words like '%$item%'";
			}
			
			// 縦幅オプションの時
			elseif ($opt === 'height') {
				$where .= "$param like '%$item'";
			}
			
			// 横幅オプションの時
			elseif ($opt === 'width') {
				$where .= "$param like '$item%'";
			}
			
			// 統合オプションの時
			elseif ($opt === 'group' && $item !== 'Linux') {
				$where .= "$param like '$item%'";
			}
			
			// 統合オプションの時
			elseif ($opt === 'group' && $item === 'Linux') {
				$where .= "($param like '%Linux%' or $param = 'Fedora' or $param = 'Ubuntu')";
			}
			
			// 検索語の時
			elseif ($opt === 'word') {
				$where .= "$param like '%$item%'";
			}
			
			// リンク元検索エンジン,ドメインオプションの時
			elseif ($opt === 'search' || $opt === 'domain') {
				$where .= self::domainWhere($db, $item);
			}
			
			// リンク元有無オプションの時
			elseif ($opt === 'exists') {
				
				// リンク元 無しの時
				if ($item === 'no_ref') {
					$where .= "$param = ''";
				}
				
				// リンク元 有り / 検索エンジンの時
				elseif ($item === 'search') {
					$where .= "search_words != ''";
				}
				
				// リンク元 有り / 通常リンクの時
				elseif ($item === 'normal') {
					$where .= "$param != '' and search_words = ''";
				}
				
			}
			
			// 訪問回数統合オプションの時
			elseif ($opt === 'repeat') {
				
				// 初回アクセスの時
				if ($item === 'first') {
					$where .= "$param != '' and $param < 2";
				}
				
				// リピートアクセスの時
				elseif ($item === 'repeat') {
					$where .= "$param != '' and $param > 1";
				}
				
			}
			
			// リンク先の時
			elseif ($param === 'click') {
				
				// 変数を別名で保持
				$p = $item;
				
				// 検索条件を設定
				$where .= "(click_route = '$p' or click_route like '$p-%' or ";
				$where .= "click_route like '%-$p-%' or click_route like '%-$p')";
				
			}
			
			// アクセスページの時
			elseif ($param === 'page') {
				
				// ディレクトリオプションが無い時
				if (!isset($GLOBALS['args'][7])) {
					
					// 変数を別名で保持
					$p = $item;
					
					// 検索条件を設定
					$where .= "(route = '$p' or route like '$p-%' or ";
					$where .= "route like '%-$p-%' or route like '%-$p')";
					
				}
				
				// ディレクトリオプションの時
				else {
					$where .= self::dirWhere($db);
				}
				
			}
			
			// 携帯フィルターの時
			elseif ($opt === 'mobile') {
				$where .= "$param = '$item'";
				$whereUA = "ua_type = 'Mobile'";
			}
			
			// PCフィルターの時
			elseif ($opt === 'pc') {
				$where .= "$param = '$item'";
				$whereUA = "ua_type = 'PC'";
			}
			
			// ロボットオプションの時
			elseif (preg_match('/xx\/(.+)\/robot/', $_SERVER['REQUEST_URI'], $match)) {
				$where .= "$param = '" . preg_replace('/%20/', ' ', $match[1]) . "'";
				$whereUA = "ua_type = 'Robot'";
			}
			
			// オプションが無い時
			elseif (!$opt) {
				$where .= "$param = '$item'";
			}
			
			// その他例外の時
			else {
				$where = '';
			}
			
		}
		
		////////////////////////////////////////////////////////////
		
		// POSTメソッドの時
		else {
			
			// 年月を取得
			$y = $GLOBALS['args']['y'];
			$m = $GLOBALS['args']['m'];
			
			// 詳細ログパラメータ配列を設定
			$params = array(
				'referrer',
				'search_word',
				'page',
				'click',
				'ua',
				'os',
				'device',
				'client_size',
				'display_size',
				'host_domain',
				'carrier',
				'city'
			);
			
			// 条件設定ループ
			foreach ($params as $param) {
				
				// 検索データが存在しない時
				if (!isset($GLOBALS['args'][$param]) || !$GLOBALS['args'][$param]) {
					continue;
				}
				
				// 一致条件名を整形
				$eq = $param . '_eq';
				
				// アクセスページの時
				if ($param === 'page' || $param === 'click') {
					
					// 項目名を取得
					$v = $GLOBALS['args'][$param];
					
					// 対象カラム名を設定
					$c = ($param === 'page') ? 'route' : 'click_route';
					
					// 検索条件を設定
					$w = " ($c = '$v' or $c like '$v-%' or $c like '%-$v-%' or $c like '%-$v')";
					
					// 含まない時はnot演算子を追記
					if ($GLOBALS['args'][$eq] === 'ne') {
						$w = ' not' . $w;
					}
					
					// 配列に格納
					$wheres[] = $w;
					
				}
				
				// 検索語の時
				elseif ($param === 'search_word') {
					
					// 項目名を取得
					$v = $GLOBALS['args'][$param];
					
					// 検索条件を設定
					$w = " (search_words like '%$v%')";
					
					// 含まない時はnot演算子を追記
					if ($GLOBALS['args'][$eq] === 'ne') {
						$w = ' not' . $w;
					}
					
					// 配列に格納
					$wheres[] = $w;
					
				}
				
				// アクセスページ以外の時
				else {
					
					// 比較演算子を設定
					$e = ($GLOBALS['args'][$eq] === 'eq') ? '=' : '!=';
					
					// 検索条件を設定
					$w = " $param $e '" . $GLOBALS['args'][$param] . "'";
					
					// 配列に格納
					$wheres[] = $w;
					
				}
				
			}
			
			// 条件に追記
			if ($wheres) {
				$where .= implode(' and', $wheres);
			}
			
			// 検索条件が無い時はwhere句をリセット
			else {
				$where = '';
			}
			
		}
		
		////////////////////////////////////////////////////////////
		
		// 日付の指定が存在する時は追記
		$day = ($d !== 'xx') ? '/' . $d : '';
		
		// メニューを出力
		echo $tab1 . '<p id="content_date">&lt; ' . $y . '/' . $m . $day . ' &gt;</p>' . "\n" . $tab1;
		
		// DB名を設定
		$atDB = 'access_' . $y . '_' . $m . '.db';
		
		// DBに接続
		$db->attach($atDB);
		
		// テーブル名を取得
		$visitTable = $db->table('visit');
		
		// クエリーを作成
		$query1 = "select count(ip_address) as count from $visitTable;";
		
		// クエリーを実行
		$allRows = $db->queryFetch($query1, 'count');
		
		// // 詳細ログが存在する時
		if ($allRows) {
			
			// クエリーを作成
			$query2 = "select * from $visitTable $table where $whereUA $where order by date desc, last_time desc;";
			
			// クエリーを実行
			$results = $db->query($query2);
			
			// クエリーを作成
			$query3 = "select count(ip_address) as count from $visitTable where $whereUA $where ;";
			
			// クエリーを実行
			$count = $db->queryFetch($query3, 'count');
			
			// パーセンテージを算出
			$per = number_format($count / $allRows * 100, 1);
			
			// メニュー項目を設定
			echo '<p id="content_filter">' . "$count / $allRows ( $per% )" . '</p>' . "\n" . $tab1 . '<section id="content_main">';
			
			// レスポンスを出力
			Visit::view($db, $tmpl, $body, $results, $count, $opt);
			
		}
		
		// データが存在しない時
		else {
			echo '<p id="content_filter">0 / 0 ( 0.0% )</p>' . "\n" . $tab1 . '<section id="content_main">';
		}
		
		// URLルートを設定
		$footVars['root'] = ROOT;
		
		// フッターテンプレートを出力
		$GLOBALS['args']['contentAll'] = $tmpl->res($foot, $footVars);
		
	}
	
	//---------------------------------------------------------
	//  ID検索
	//---------------------------------------------------------
	
	private static function visitorId($db, $tmpl, $body, $visitorId) {
		
		// テーブル名を取得
		$visitTable = $db->table('visit');
		
		// インデントタブを設定
		$tab1 = "\t\t\t";
		$tab2 = $tab1 . "\t";
		
		// DB名を取得
		$files = glob("DATA_DIR/access*.db");
		
		// 配列を降順でソート
		rsort($files);
		
		// where句を設定
		$where = "where visitor_id = '$visitorId'";
		
		// ヘッダーを出力
		echo $tab1 . '<section id="content_main">' . "\n";
		echo $tab2 . '<p id="content_date">' . "&lt; $visitorId &gt;" . '</p>';
		
		// DB名を取得するループ
		foreach ($files as $file) {
			
			// メインDBの時は次へ
			if (preg_match('/_main/', $file)) {
				continue;
			}
			
			// ファイル名を切り出す
			$atDB = basename($file);
			
			// DBに接続
			$db->attach($atDB);
			
			//////////////////////////////////////////////////////////////////////
			
			// クエリーを作成
			$query1 = "select count(ip_address) as count from $visitTable $where;";
			
			// クエリーを実行
			$count = $db->queryFetch($query1, 'count');
			
			// データが無い時
			if (!$count) {
				
				// 追加接続を解除
				$db->detach();
				
				// 次へ
				continue;
				
			}
			
			// クエリーを作成
			$query2 = "select * from $visitTable $where order by date desc, last_time desc;";
			
			// クエリーを実行
			$results = $db->query($query2);
			
			// レスポンスを出力
			Visit::view($db, $tmpl, $body, $results, $count, 'id');
			
			// DBから切断
			$db->detach();
			
		}
		
		// ポップアップ<script>を出力
		echo "\n" . $tab2 . '<p id="pop"></p>';
		echo "\n" . $tab2 . '<script type="text/javascript" src="' . ROOT . '/popup/"></script>';
		
	}
	
	//---------------------------------------------------------
	//  ドメインデータ取得
	//---------------------------------------------------------
	
	private static function domainWhere($db, $item) {
		
		// 配列を初期化
		$wheres = array();
		
		// テーブル名を取得
		$pageTable = $db->table('referrer');
		
		// クエリーを作成
		$query = "select id from $pageTable where url like '%$item%';";
		
		// クエリーを実行
		$results = $db->query($query);
		
		// 検索条件を配列にセット
		while ($rec = $db->fetch($results)) {
			$wheres[] = 'referrer = ' . $rec['id'];
		}
		
		// 検索条件に結合
		$where = '(' . implode(' or ', $wheres) . ')';
		
		// where句を返す
		return $where;
		
	}
	
	//---------------------------------------------------------
	//  ディレクトリデータ取得
	//---------------------------------------------------------
	
	private static function dirWhere($db) {
		
		// 配列を初期化
		$wheres = array();
		
		// 変数を初期化
		$where = 'like';
		
		// ディレクトリを取得
		$dir1 = preg_replace("/.*\/(http.+\/)dir\//", "$1", $_SERVER['REQUEST_URI']);
		
		// 「/」をエスケープ
		$dir2 = preg_replace('/\//', '\/', $dir1);
		
		// テーブル名を取得
		$pageTable = $db->table('page');
		
		// クエリーを作成
		$query = "select id, url from $pageTable where url like '$dir1%';";
		
		// クエリーを実行
		$results = $db->query($query);
		
		// データ取得ループ
		while ($rec = $db->fetch($results)) {
			
			// URLからディレクトリを削除
			$page = preg_replace("/$dir2/", '', $rec['url']);
			
			// 「/」が含まれる場合は次へ
			if (preg_match('/\//', $page)) {
				continue;
			}
			
			// データを取得
			$id = $rec['id'];
			
			// 検索条件を配列にセット
			$wheres[] = "route = '$id' or route like '$id-%' or route like '%-$id-%' or route like '%-$id'";
			
		}
		
		// 検索条件に結合
		$where = '(' . implode(' or ', $wheres) . ')';
		
		// where句を返す
		return $where;
		
	}
	
}

