
// JavaScriptのパスを取得
var jsPath = document.getElementById('lunalys').src;

// PHPのパスを取得
var phpPath = jsPath.replace(/add.js/, 'write.php');

// ドメイン一致の正規表現
var regExp = new RegExp('^(http|https)://' + document.domain);

//////////////////////////////////////////////////////////////

// URL引数
var args = '';

// ディスプレイの幅を追記
args += '&display_width=' + screen.width;

// ディスプレイの高さを追記
args += '&display_height=' + screen.height;

//////////////////////////////////////////////////////////////

// documentElement が使える時
if (document.documentElement) {
	
	// ブラウザ表示領域の幅を追記
	args += '&client_width=' + parent.document.documentElement.clientWidth;
	
	// ブラウザ表示領域の高さを追記
	args += '&client_height=' + parent.document.documentElement.clientHeight;
	
}

//////////////////////////////////////////////////////////////

// リクエストURLを設定
var url = phpPath + '?act=add&guid=ON' + args + '&cache=' + (new Date()).getTime();

// リクエスト送信（script追加）
addElement(url);

// リクエスト送信（Ajax）
//sendAjax(url);

// ページ読み込み完了後にイベントを設定
if (window.addEventListener) {
	window.addEventListener('load', setEvent, {passive: false});
}

//////////////////////////////////////////////////////////////

// 文字列をURLエンコード
function encodeStr(str) {
	
	// 特定の文字をエンコード
	str = str.replace(/\?/g,'%3F');
	str = str.replace(/&/g,'%26');
	str = str.replace(/#/g,'%23');
	str = str.replace(/=/g,'%3D');
	str = str.replace(/ /g,'%20');
	
	// 変換後の文字列を返す
	return str;
	
}

//////////////////////////////////////////////////////////////

// リンククリック時のイベントを設定
function setEvent() {
	
	// 正規表現を設定（対象ドメイン）
	var regExp = new RegExp('^(http|https)://' + document.domain);
	
	// 正規表現を設定（既知の拡張子）
	var pageExt = /\.(htm|php|cgi|jsp|asp)/i;
	
	// 正規表現を設定（未知の拡張子）
	var fileExt = /\.\w{2,4}$/i;
	
	// イベント種別を設定
	var eventType = (window.ontouchstart === undefined) ? 'mousedown' : 'touchstart';
	
	// リンクの総数を取得
	var length = document.getElementsByTagName('a').length;
	
	// リンクの数だけループ
	for (i = 0; i < length; i++) {
		
		// a要素を取得
		var node = document.getElementsByTagName('a')[i];
		
		// href属性を取得
		var href = node.href;
		
		// JavaScript実行の時は次へ
		if (href.match('javascript')) {
			continue;
		}
		
		// 違うドメイン、ファイルダウンロードの時はイベントを設定
		else if (!href.match(regExp) || (!href.match(pageExt) && href.match(fileExt))) {
			node.addEventListener(eventType, clickLink, {passive: true});
		}
		
	}
	
}

//////////////////////////////////////////////////////////////

// リンククリック時にリクエスト送信
function clickLink() {
	
	// URL引数
	var args = '';
	
	// encodeURIComponent が使える時
	if (window.encodeURIComponent) {
		
		// URLを追記
		args += '&url=' + encodeURIComponent(this.href);
		
		// タイトルを追記
		args += '&title=' + encodeURIComponent(this.innerHTML);
		
	}
	
	// encodeURIComponent が使えない時
	else {
		
		// URLを追記
		args += '&url=' + encodeStr(this.href);
		
		// タイトルを追記
		args += '&title=' + encodeStr(this.innerHTML);
		
	}
	
	// リクエストURLを設定
	var url = phpPath + '?act=click' + args;
	
	// リクエスト送信（script追加）
	addElement(url);
	
	// リクエスト送信（Ajax）
	//sendAjax(url);
	
}

//////////////////////////////////////////////////////////////

// リクエスト送信（script追加）
function addElement(url) {
	
	// 要素を作成
	var script = document.createElement('script');
	
	// 属性を設定
	script.setAttribute('src', url);
	script.setAttribute('type', 'text/javascript');
	script.setAttribute('async', true);
	
	// head要素を取得
	var head = document.getElementsByTagName('head')[0];
	
	// head要素の最後に追記
	head.appendChild(script);
	
	// 最初の要素を取得
	//var firstScript = document.getElementsByTagName('script')[0];
	
	// 作成した要素を追記
	//firstScript.parentNode.insertBefore(script, firstScript);
	
}

//////////////////////////////////////////////////////////////

// リクエスト送信（Ajax）
function sendAjax(url) {
	
	// リクエストオブジェクトを作成
	var xhr = new XMLHttpRequest();
	
	// Cookieを許可する
	xhr.withCredentials = true;
	
	// リクエストを開く
	xhr.open('GET', url);
	
	// リクエストを送信
	xhr.send();
	
}

