<?php

class Add {
	
	//---------------------------------------------------------
	//  パラメータ追記
	//---------------------------------------------------------
	
	public static function addParam($db, $whereOrderBy, $visitorId, $visitCount) {
		
		// テーブル名を取得
		$visitTable = $db->table('visit');
		
		// ディスプレイ解像度、ブラウザ表示領域を取得
		list($displaySize, $clientSize) = ClientSize::parseSize();
		
		// クエリーを作成
		$selectQuery = "select seq, display_size from $visitTable $whereOrderBy;";
		
		// クエリーを実行
		$result = $db->queryFetch($selectQuery);
		
		// データが存在しないもしくは追記済の時は終了
		if (!$result || $result['display_size']) {
			return $db->close();
		}
		
		// シークエンスを取得
		$seq = $result['seq'];
		
		// 訪問回数を増やす
		$visitCount++;
		
		// クエリーを作成
		$updateQuery = "update $visitTable set display_size = '$displaySize', client_size = '$clientSize', visitor_id = '$visitorId', visit_count = $visitCount where seq = $seq;";
		
		// クエリーを実行
		$db->query($updateQuery);
		
		// パラメータ統計テーブルを更新
		Logging::updateParamTable($db, 'display_size', $displaySize);
		Logging::updateParamTable($db, 'client_size', $clientSize);
		
		// 再訪の時はテーブルを更新
		if ($visitCount > 1) {
			Logging::updateParamTable($db, 'visit_count', $visitCount);
		}
		
		// DB接続終了
		$db->close();
		
		// Cookieを発行
		Logging::saveCookie($visitorId, $visitCount);
		
	}
	
}

