<?php

class Click {
	
	//---------------------------------------------------------
	//  リンク先追記
	//---------------------------------------------------------
	
	public static function addClick($db, $whereOrderBy) {
		
		// テーブル名を取得
		$visitTable = $db->table('visit');
		
		// テーブル更新フラグ
		$doUpdate = true;
		
		// クリックルート
		$clickRoute = '';
		
		// IDを取得
		$clickId = self::parseId($db);
		
		// クエリーを作成
		$selectQuery = "select seq, click_route from $visitTable $whereOrderBy;";
		
		// クエリーを実行
		$rec = $db->queryFetch($selectQuery);
		
		// データが存在しない時
		if (!$rec || !$clickId) {
			$doUpdate = false;
		}
		
		// クリックルートが存在する時
		elseif ($rec['click_route']) {
			
			// クリックルートを取得
			$clickRoute = $rec['click_route'];
			
			// ルートを分割
			$ids = explode('-', $clickRoute);
			
			// クリック総数を取得
			$clickCount = count($ids);
			
			// 配列の最終indexを算出
			$lastIndex = $clickCount - 1;
			
			// IDが同じ時は終了（リロード）
			if ($clickId === $ids[$lastIndex]) {
				$doUpdate = false;
			}
			
			// クリックルートにIDを追加
			$clickRoute .= '-' . $clickId;
			
		}
		
		// クリックルートが存在しない時
		else {
			$clickRoute = $clickId;
		}
		
		// 更新フラグがfalseの時
		if (!$doUpdate) {
			return $db->close();
		}
		
		// シークエンスを取得
		$seq = $rec['seq'];
		
		// クエリーを作成
		$updateQuery = "update $visitTable set click_route = '$clickRoute' where seq = $seq;";
		
		// クエリーを実行
		$db->query($updateQuery);
		
		// パラメータ統計テーブルを更新
		Logging::updateParamTable($db, 'click', $clickId);
		
		// DB接続終了
		$db->close();
		
	}
	
	//---------------------------------------------------------
	//  クリックページIDを取得
	//---------------------------------------------------------
	
	private static function parseId($db) {
		
		// URLを取得
		$url = (isset($_GET['url'])) ? strip_tags($_GET['url']) : '';
		
		// タイトルを取得
		$title = (isset($_GET['title'])) ? strip_tags($_GET['title']) : '';
		
		// タイトルの前後の空白を削除
		$title = trim($title);
		
		// サーバーのドメインを取得
		$httpHost = $_SERVER['HTTP_HOST'];
		
		// 外部リンク判定を取得
		$isExtUrl = (preg_match("/(http|https):\/\/[^\/]*($httpHost)/A", $url)) ? false : true;
		
		// URLを整形
		$url = Logging::rewriteUrl($url, $isExtUrl);
		
		// URLが存在しない時0を返す
		if (!$url) {
			return 0;
		}
		
		// タイトルが存在しない時はURLをセット
		elseif (!$title) {
			$title = $url;
		}
		
		////////////////////////////////////////////////////////////
		
		// テーブル名を取得
		$clickTable = $db->table('click');
		
		// URLをエスケープ
		$url = $db->escape($url);
		
		// クエリーを作成
		$selectIdQuery = "select id from $clickTable where url = $url;";
		
		// クエリーを実行
		$id = $db->queryFetch($selectIdQuery, 'id');
		
		// IDが存在する時はIDを返す
		if ($id) {
			return $id;
		}
		
		// クエリーを作成
		$selectMaxQuery = "select max(id) as max from $clickTable;";
		
		// クエリーを実行
		$max = $db->queryFetch($selectMaxQuery, 'max');
		
		// 次のIDを算出
		$nextId = ($max) ? $max + 1 : 1;
		
		// URLをエスケープ
		$title = $db->escape($title);
		
		// クエリーを作成
		$insertQuery = "insert into $clickTable (id, url, title) values ($nextId, $url, $title);";
		
		// クエリーを実行
		$db->query($insertQuery);
		
		// IDを返す
		return $nextId;
		
	}
	
}

